unit Demo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, CAD2DCmp, GrLib2D, ExtCtrls, Prim2D;

type
  TForm2 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    CADCmp1: TCADCmp;
    ViewPort1: TViewPort;
    Timer1: TTimer;
    CheckBox1: TCheckBox;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    FState: Byte;
    Stop: Boolean;
    procedure Delay;
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

procedure TForm2.FormCreate(Sender: TObject);
begin
  FState := 0;
  Button1Click(nil);
  CADCmp1.Layers[0].Brush.Color := clGreen;
  CADCmp1.Layers[1].Brush.Color := clRed;
  CADCmp1.Layers[1].Pen.Color := clRed;
  CADCmp1.Layers[2].Pen.Style := psDash;
  ViewPort1.ZoomWindow(Rect2D(-20, -20, 20, 20));
end;

procedure TForm2.Delay;
begin
  Stop := not CheckBox1.Checked;
  while Stop = False do Application.ProcessMessages;
end;

procedure TForm2.Button1Click(Sender: TObject);
var
  Cont, St: LongInt;
  Pts1: array [1..24] of TPoint2D;
  Pts2: array [1..12] of TPoint2D;
  Obj: TPrimitive2D;
begin
  Button1.Enabled := False;
  case FState of
   0: begin
        Label1.Caption := 'Polygon are drawed easily in real plane.';
        St := 1;
        for Cont := 1 to 12 do
         begin
           Pts1[St].X := 10 * cos(St * 2 * Pi / 24);
           Pts1[St].Y := 10 * sin(St * 2 * Pi / 24);
           St := St + 1;
           Pts1[St].X := 15 * cos(St * 2 * Pi / 24);
           Pts1[St].Y := 15 * sin(St * 2 * Pi / 24);
           St := St + 1;
         end;
        CADCmp1.Polygon(0, Pts1); 
        St := 1;
        CADCmp1.CurrentLayer := 1;
        for Cont := 1 to 6 do
         begin
           Pts2[St].X := 5 * cos(St * 2 * Pi / 12);
           Pts2[St].Y := 5 * sin(St * 2 * Pi / 12);
           St := St + 1;
           Pts2[St].X := 9 * cos(St * 2 * Pi / 12);
           Pts2[St].Y := 9 * sin(St * 2 * Pi / 12);
           St := St + 1;
         end;
        CADCmp1.Polygon(1, Pts2);
      end;
   1: begin
        Label1.Caption := 'Easy change of viewport extension.';
        for Cont := 1 to 3 do
         begin
           ViewPort1.ZoomIn;
           Delay;
         end;
        for Cont := 1 to 5 do
         begin
           ViewPort1.ZoomOut;
           Delay;
         end;
        for Cont := 1 to 3 do
         begin
           ViewPort1.Panning(-Cont, -Cont);
           Delay;
         end;
        for Cont := 1 to 3 do
         begin
           ViewPort1.Panning(Cont, Cont);
           Delay;
         end;
      end;
   2: begin
        Label1.Caption := 'All affine trasformation are supported.';
        for Cont := 1 to 10 do
         begin
           CADCmp1.TrasformObjects([0, 1], Rotate2D(Pi/8));
           Delay;
         end;
        for Cont := 1 to 10 do
         begin
           CADCmp1.TrasformObjects([0, 1], Rotate2D(-Pi/8));
           Delay;
         end;
        for Cont := 1 to 10 do
         begin
           CADCmp1.TrasformObjects([1], Traslate2D(-1, 0));
           Delay;
         end;
        for Cont := 1 to 10 do
         begin
           CADCmp1.TrasformObjects([1], Traslate2D(1, 0));
           Delay;
         end;
        for Cont := 1 to 10 do
         begin
           CADCmp1.TrasformObjects([1], Scale2D(0.9, 0.9));
           Delay;
         end;
        for Cont := 1 to 10 do
         begin
           CADCmp1.TrasformObjects([1], Scale2D(1.1, 1.1));
           Delay;
         end;
      end;
   3: begin
        Label1.Caption := 'Easily implemention of rubber band.';
        Obj := TRectangle2D.Create(2, Point2D(-15, -15) , Point2D(5, 5));
        Obj.Layer := 2;
        ViewPort1.WhereToDraw := [wdCanvas];
        for Cont := 20 downto 0 do
         begin
           ViewPort1.ReFresh;
           ViewPort1.DrawObject(Obj);
           Obj.Points[0] := Point2D(5 - Cont, 5 - Cont);
           Delay;
         end;
        for Cont := 0 to 20 do
         begin
           ViewPort1.ReFresh;
           ViewPort1.DrawObject(Obj);
           Obj.Points[0] := Point2D(5 - Cont, 5 - Cont);
           Delay;
         end;
        ViewPort1.WhereToDraw := [wdOffScreen];
      end;
   4: begin
        Label1.Caption := 'Use of Window fonts.';
        Obj := TText2D.Create(2, Point2D(-50, 0) , 5, 'Hello word');
        Obj.Layer := 2;
        ViewPort1.WhereToDraw := [wdCanvas];
        for Cont := -50 to 20 do
         begin
           ViewPort1.ReFresh;
           ViewPort1.DrawObject(Obj);
           Obj.Points[0] := Point2D(Cont, 0);
           Delay;
         end;
        ViewPort1.WhereToDraw := [wdOffScreen];
      end;
   5: begin
        Label1.Caption := 'And more function and primitives in the future';
        Exit;
      end;
  end;
  Inc(FState);
  Button1.Enabled := True;
end;

procedure TForm2.Timer1Timer(Sender: TObject);
begin
  Stop := True;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  FState := 1;
end;

end.
